"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var TNSRTCRtpTransceiverBase_1 = require("../base/TNSRTCRtpTransceiverBase");
var TNSRTCRtpTransceiverDirection_1 = require("../core/TNSRTCRtpTransceiverDirection");
var TNSRTCRtpReceiver_1 = require("./TNSRTCRtpReceiver");
var TNSRTCRtpSender_1 = require("./TNSRTCRtpSender");
var TNSRTCRtpTransceiver = (function (_super) {
    __extends(TNSRTCRtpTransceiver, _super);
    function TNSRTCRtpTransceiver(transceiver) {
        var _this = _super.call(this, transceiver) || this;
        _this._transceiver = transceiver;
        return _this;
    }
    TNSRTCRtpTransceiver.fromNative = function (transceiver) {
        return new TNSRTCRtpTransceiver(transceiver);
    };
    TNSRTCRtpTransceiver.prototype.stop = function () {
        this._transceiver.stop();
    };
    Object.defineProperty(TNSRTCRtpTransceiver.prototype, "direction", {
        get: function () {
            switch (this._transceiver.direction) {
                case 0:
                    return TNSRTCRtpTransceiverDirection_1.TNSRTCRtpTransceiverDirection.INACTIVE;
                case 1:
                    return TNSRTCRtpTransceiverDirection_1.TNSRTCRtpTransceiverDirection.RECV_ONLY;
                case 2:
                    return TNSRTCRtpTransceiverDirection_1.TNSRTCRtpTransceiverDirection.SEND_ONLY;
                case 3:
                    return TNSRTCRtpTransceiverDirection_1.TNSRTCRtpTransceiverDirection.SEND_RECV;
                default:
                    return TNSRTCRtpTransceiverDirection_1.TNSRTCRtpTransceiverDirection.INACTIVE;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSRTCRtpTransceiver.prototype, "currentDirection", {
        get: function () {
            switch (this._transceiver.currentDirection) {
                case 0:
                    return TNSRTCRtpTransceiverDirection_1.TNSRTCRtpTransceiverDirection.INACTIVE;
                case 1:
                    return TNSRTCRtpTransceiverDirection_1.TNSRTCRtpTransceiverDirection.RECV_ONLY;
                case 2:
                    return TNSRTCRtpTransceiverDirection_1.TNSRTCRtpTransceiverDirection.SEND_ONLY;
                case 3:
                    return TNSRTCRtpTransceiverDirection_1.TNSRTCRtpTransceiverDirection.SEND_RECV;
                default:
                    return null;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSRTCRtpTransceiver.prototype, "mid", {
        get: function () {
            return this._transceiver.mid;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSRTCRtpTransceiver.prototype, "receiver", {
        get: function () {
            return TNSRTCRtpReceiver_1.TNSRTCRtpReceiver.fromNative(this._transceiver.receiver);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSRTCRtpTransceiver.prototype, "sender", {
        get: function () {
            return TNSRTCRtpSender_1.TNSRTCRtpSender.fromNative(this._transceiver.sender);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSRTCRtpTransceiver.prototype, "stopped", {
        get: function () {
            return this._transceiver.stopped;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSRTCRtpTransceiver.prototype, "instance", {
        get: function () {
            return this._transceiver;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSRTCRtpTransceiver.prototype, "ios", {
        get: function () {
            return this._transceiver.rtpTransceiver;
        },
        enumerable: true,
        configurable: true
    });
    return TNSRTCRtpTransceiver;
}(TNSRTCRtpTransceiverBase_1.TNSRTCRtpTransceiverBase));
exports.TNSRTCRtpTransceiver = TNSRTCRtpTransceiver;
//# sourceMappingURL=TNSRTCRtpTransceiver.js.map