"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var TNSRTCTrackEventBase_1 = require("../base/TNSRTCTrackEventBase");
var TNSRTCMediaStreamTrack_1 = require("./TNSRTCMediaStreamTrack");
var TNSRTCRtpTransceiver_1 = require("./TNSRTCRtpTransceiver");
var TNSRTCRtpReceiver_1 = require("./TNSRTCRtpReceiver");
var TNSRTCMediaStream_1 = require("./TNSRTCMediaStream");
var TNSRTCTrackEvent = (function (_super) {
    __extends(TNSRTCTrackEvent, _super);
    function TNSRTCTrackEvent(event) {
        var _this = _super.call(this, event) || this;
        _this._event = event;
        return _this;
    }
    Object.defineProperty(TNSRTCTrackEvent.prototype, "track", {
        get: function () {
            return this.mediaTrack;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSRTCTrackEvent.prototype, "mediaTrack", {
        get: function () {
            return TNSRTCMediaStreamTrack_1.TNSRTCMediaStreamTrack.fromNative(this._event.mediaTrack);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSRTCTrackEvent.prototype, "transceiver", {
        get: function () {
            return TNSRTCRtpTransceiver_1.TNSRTCRtpTransceiver.fromNative(this._event.transceiver);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSRTCTrackEvent.prototype, "receiver", {
        get: function () {
            return TNSRTCRtpReceiver_1.TNSRTCRtpReceiver.fromNative(this._event.receiver);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSRTCTrackEvent.prototype, "streams", {
        get: function () {
            var array = [];
            var nativeArray = this._event.streams;
            if (!nativeArray)
                return array;
            var size = nativeArray.count;
            for (var i = 0; i < size; i++) {
                var stream = nativeArray.objectAtIndex(i);
                array.push(TNSRTCMediaStream_1.TNSRTCMediaStream.fromNative(stream));
            }
            return array;
        },
        enumerable: true,
        configurable: true
    });
    TNSRTCTrackEvent.fromNative = function (event) {
        return new TNSRTCTrackEvent(event);
    };
    return TNSRTCTrackEvent;
}(TNSRTCTrackEventBase_1.TNSRTCTrackEventBase));
exports.TNSRTCTrackEvent = TNSRTCTrackEvent;
//# sourceMappingURL=TNSRTCTrackEvent.js.map