import { Common, Quality, WebRTCDataChannelMessageType, WebRTCIceCandidate, WebRTCOptions, WebRTCSdp } from './webrtc.common';
import { View } from 'tns-core-modules/ui/core/view';
export * from './src/android';
export { IceConnectionState, IceServer, IceGatheringState, Quality, SignalingState, WebRTCDataChannelMessageType, WebRTCDataChannelState, WebRTCIceCandidate, WebRTCOptions, WebRTCSdp, WebRTCSdpType, WebRTCState } from './webrtc.common';
export declare class WebRTC extends Common {
    private webrtc;
    constructor(options?: WebRTCOptions);
    static requestPermissions(explanation?: string): Promise<any>;
    static hasPermissions(): boolean;
    private static _callbackFn;
    private static callback;
    static init(): void;
    dataChannelSend(name: string, data: string, type: WebRTCDataChannelMessageType): void;
    dataChannelClose(name: string): void;
    dataChannelCreate(name: string): void;
    switchCamera(trackId: string): void;
    handleAnswerReceived(answer: WebRTCSdp): void;
    connect(): void;
    disconnect(): void;
    micEnabled(enabled: boolean): void;
    toggleMic(): void;
    speakerEnabled(enabled: boolean): void;
    createAnswerForOfferReceived(sdp: WebRTCSdp): void;
    makeOffer(): void;
    addLocalStream(stream: any): void;
    addIceCandidate(iceCandidate: WebRTCIceCandidate): void;
    enableTrack(trackId: string, enable: boolean): void;
    getUserMedia(quality?: Quality): Promise<any>;
}
export declare enum TNSRTCScaling {
    FIT = "fit",
    FILL = "fill",
    NONE = "none"
}
export declare class WebRTCView extends View {
    private _stream;
    private _scaling;
    createNativeView(): any;
    initNativeView(): void;
    mirror: boolean;
    scaling: TNSRTCScaling;
    videoTrack: any;
    stream: any;
    srcObject: any;
}
