import { Common, Quality, WebRTCDataChannelMessageType, WebRTCIceCandidate, WebRTCOptions, WebRTCSdp } from './webrtc.common';
import { View } from 'tns-core-modules/ui/core/view';
import './async-await';
export { IceConnectionState, IceServer, IceGatheringState, Quality, SignalingState, WebRTCDataChannelMessageType, WebRTCDataChannelState, WebRTCIceCandidate, WebRTCOptions, WebRTCSdp, WebRTCSdpType, WebRTCState } from './webrtc.common';
export * from './src/ios';
export declare class WebRTC extends Common {
    private connection;
    private connectionFactory;
    private configuration;
    private constraints;
    private _delegate;
    private defaultConnectionConstraints;
    private remoteIceCandidates;
    remoteStream: any;
    remoteTracks: Array<any>;
    private tracks;
    private localStreams;
    private remoteStreams;
    private _dataChannels;
    constructor(options?: WebRTCOptions);
    readonly delegate: any;
    readonly dataChannels: Map<string, any>;
    private static requestCameraPermission;
    private static requestAudioPermission;
    static requestPermissions(explanation?: string): Promise<any>;
    private static hasCameraPermission;
    private static hasAudioPermission;
    static hasPermissions(): boolean;
    makeOffer(): void;
    handleAnswerReceived(answer: WebRTCSdp): void;
    addIceCandidate(iceCandidate: WebRTCIceCandidate): void;
    createAnswerForOfferReceived(sdp: WebRTCSdp): void;
    private handleRemoteDescriptionSet;
    private handleSdpGenerated;
    static init(): void;
    connect(): void;
    disconnect(): void;
    addLocalStream(stream: any): void;
    addRemoteStream(stream: any): void;
    dataChannelSend(name: string, data: string, type: WebRTCDataChannelMessageType): void;
    dataChannelClose(name: string): void;
    dataChannelCreate(name: string): void;
    switchCamera(trackId: string): void;
    private registerDataChannelDelegate;
    private getRandomId;
    getUserMedia(quality?: Quality): Promise<any>;
    micEnabled(enabled: boolean): void;
    toggleMic(): void;
    speakerEnabled(enabled: boolean): void;
    enableTrack(trackId: string, enabled: boolean): void;
}
export declare enum TNSRTCScaling {
    FIT = "fit",
    FILL = "fill",
    NONE = "none"
}
export declare class WebRTCView extends View {
    private _scaling;
    createNativeView(): Object;
    initNativeView(): void;
    mirror: boolean;
    videoTrack: any;
    stream: any;
    scaling: TNSRTCScaling;
    srcObject: any;
    onMeasure(widthMeasureSpec: number, heightMeasureSpec: number): void;
}
